import typing

from sqlalchemy.engine.url import URL
from sqlalchemy.ext.asyncio import AsyncEngine

from pbt_database import Database, get_session

from .conftest import stub_env


def test_database():
    """Test env definition."""
    database = Database.from_env()
    assert isinstance(database, Database)
    assert database.dsn == URL.create(
        drivername='postgresql+asyncpg',
        host=stub_env['DB_HOST'],
        port=stub_env['DB_PORT'],
        database=stub_env['DB_NAME'],
        username=stub_env['DB_USER'],
        password=stub_env['DB_PASSWORD'],
    )
    assert isinstance(database.engine, AsyncEngine)
    assert isinstance(get_session(database.engine), typing.AsyncGenerator)
